﻿{

	//===================== Original header start
	//	Subtitle generator by !Rocky
	//	modified by Colin Harman ( http://colinharman.com/ ) to work on a Mac
	//
	//	Save this code as
	//	"subtitles.jsx"
	//
	//	Create a text file with your subtitles.
	//	Each line of text is one on-screen line.
	//	To have several lines on-screen at the same time,
	//	simply separate them with a pipe ( | ) character.
	//	eg "Character 1 talks|Character 2 interrupts"
	//
	//	Create a new text layer in your comp, adjust its position,
	//	make sure the text's centered, so it looks nice
	//	Add markers (Numpad *) where each subtitle line must be shown/hidden.
	//	With the text layer selected, run the script, and select the subtitles file.
	//	Enjoy!
	//===================== Original header end
	
	//	modified by Eric to work with standard srt with simple effects


    function pad2(number) {
         return (number < 10 ? '0' : '') + number
    }

    function addTime( gettimestr,  sec,msec){
            var parse = gettimestr.split(":"); //00:00:00:00
            var tempsec = pad2(Number(parse[2])+sec);
            var tempmsec = pad2(Number(parse[3])+msec);
            if (tempsec > 60){
                 parse[1] = pad2(Number(parse[1])+(tempsec/60).toInt).toString ();
                 tempsec -= ((tempsec/60).toInt*60);
                }
            parse[2] = tempsec.toString ();
            parse[3] = tempmsec.toString ();
            return currentFormatToTime(parse.join(":"),25);
        }
	function subTime( gettimestr,  sec,msec){
            var parse = gettimestr.split(":"); //00:00:00:00
			
			var tempsec = pad2(Number(parse[2])-sec);
			if( Number(parse[3]) == 0){
				 var tempmsec = 0;
				 tempsec -= 1;
				}
			else{	
				var tempmsec = pad2(Number(parse[3])-msec);
			}
			

            if (tempsec > 60){
                 parse[1] = pad2(Number(parse[1])+(tempsec/60).toInt).toString ();
                 tempsec -= ((tempsec/60).toInt*60);
                }
            parse[2] = tempsec.toString ();
            parse[3] = tempmsec.toString ();
			//alert(parse[3]);
            return currentFormatToTime(parse.join(":"),25);
        }


	function makeSubs() {
		var layer = app.project.activeItem.selectedLayers[0]; //get layer
        //var type_on = app.project.activeItem.selectedProperties[0];
        
		if (layer.property("sourceText") != null) {
			var textFile = fileGetDialog("Select a text file to open.", "");
			if (textFile != null) {
				var textLines = new Array();
				textFile.open("r", "TEXT", "????");

				while (!textFile.eof)
					textLines[textLines.length] = textFile.readln();

				textFile.close();
                
                //Clear existing
                  var sourceText = layer.property("sourceText");
				for (var i = sourceText.numKeys; i >= 1; i--)
					sourceText.removeKey(i);

                   var opacity = layer.property("opacity");
				for (var i = opacity.numKeys; i >= 1; i--)
					opacity.removeKey(i);
                    
                    customvalid =false;
                    
                 //var type_on = layer.Effects.property("Type_on").property("Slider");
				 var type_on = null;
                  if (type_on != null){
                     // alert(type_on.name());
                      customvalid =true;
                    for (var i = type_on.numKeys; i >= 1; i--)
                        type_on.removeKey(i);
                    }
                
				//alert(textLines[0]);
                  var count =1;
				for (var i = 0; i < textLines.length; i++)
				{
                        if(textLines[i] == count){
                            //read oneline below for time
                             i++;
                             //alert(textLines[i]);
                              var parsetime = textLines[i].split(" --> ");
                                var start_time = parsetime[0].split(",")[0];
                                var end_time = parsetime[1].split(",")[0];
                                
                                //var startsec = Number(parsetime[0].split(",")[1])/1000*30;
                                //var endsec = Number(parsetime[1].split(",")[1])/1000*30;
                               
                              //var startNum = currentFormatToTime(start_time+":"+startsec.toString(),25);
                              //var endNum = currentFormatToTime(end_time+":"+endsec.toString(),25);
							  var startNum = currentFormatToTime(start_time,25); //full stamp 00:00:40:30
							  var endNum = currentFormatToTime(end_time,25);
                              //alert(test);
                              
                              //// try setting Type_on //doesnt work at the moment, cannot get to the slider under effects
							  
						var pre_end = subTime(end_time,0,2);

							//// Fade In
							//alert(subTime(end_time,0,2));

							var fadeIn_end = addTime(start_time,0,10);
							opacity.setValueAtTime(startNum, 0);
							opacity.setValueAtTime(fadeIn_end, 100);
							opacity.setValueAtTime(pre_end, 100); //no fadeout
							//opacity.setValueAtTime(endNum, 0); // fadeout
							/*
							if(customvalid){
							type_on.setValueAtTime(fadeIn_end, 0);
							type_on.setValueAtTime(addTime(start_time,1,00), 100);
							type_on.setValueAtTime(pre_end, 100);
							}
							*/

							i++;
							var content = textLines[i];

							sourceText.setValueAtTime(startNum, new TextDocument(content));
							sourceText.setValueAtTime(endNum, "");
							i++;
                              
							count +=1;
                        }
                    
                    
				}
            
            
				/*
				var sourceText = layer.property("sourceText");
				var markers = layer.property("marker");

				for (var i = sourceText.numKeys; i >= 1; i--)
					sourceText.removeKey(i);

				var line = 0;
				var subTime, subText;
				
				for (var i = 1; i <= markers.numKeys; i++) {
					subTime = markers.keyTime(i);
					sourceText.setValueAtTime(0, " ");

					if ((i % 2) == 0) {
						subText = " ";
					}
					else {
						subText = textLines[line].replace("|", "\x0d\x0a");
						line++;
					}
					sourceText.setValueAtTime(subTime, new TextDocument(subText));
				}
				*/
				
				
			}
		}
	}
	makeSubs();
}